/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TCentralComponent_h_
#define _TCentralComponent_h_
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
class TCentralComponent  : public Component,
                           public ButtonListener,
                           public ChangeListener
{
public:
    TCentralComponent();
    ~TCentralComponent();

    void paint(Graphics&);
    void resized();
    // Функция, отслеживающая щелчки по кнопке
    void buttonClicked(Button*);
    void changeListenerCallback(ChangeBroadcaster*);

private:
    // Текущий файл для воспроизведения
    File CurrentFile;

    // Менеджер аудио- и MIDI-устройств
    AudioDeviceManager* pAudioDeviceManager;
    // Аудио-устройство
    AudioIODevice* pAudioDevice;
    // Промежуточное звено между источником звука
    // и аудио-устройством
    AudioSourcePlayer AudioPlayer;
    // Источник воспроизведения звука
    AudioTransportSource TransportSource;
    // Класс для принятия данных от чтеца аудио-потока
    AudioFormatReaderSource* pCurrentAudioFileSource;

    // Ярлык для вывода названия аудио-устройства
    // при запуске программы, а в последующем -
    // названия открытого аудио-файла
    Label* pNameLabel;
    // Кнопка вызова диалога выбора файла
    TextButton* pChooseButton;
    // Кнопка начала / остановки воспроизведения
    TextButton* pPlayButton;

    // Компонент выбора файла
    FilenameComponent* pFileNameDialog;

    // Предотвращает создание копии конструктора и оператора =
    TCentralComponent(const TCentralComponent&);
    const TCentralComponent& operator= (const TCentralComponent&);
};
//---------------------------------------------------------------------
#endif
