/* Andrey N. Kuznetsov, Almaty, 2012 *
 * For educational purposes.         *
 * Under GPL 2.0                     */
//---------------------------------------------------------------------
#ifndef _TCentralComponent_h_
#define _TCentralComponent_h_
//---------------------------------------------------------------------
#include "../JuceLibraryCode/JuceHeader.h"
//---------------------------------------------------------------------
class TCentralComponent : public Component,
                          public ComboBoxListener,
                          public ButtonListener
{
public:
    TCentralComponent();
    ~TCentralComponent();

    void paint(Graphics&);
    void resized();
    void comboBoxChanged(ComboBox*);
    void buttonClicked(Button*);

private:
    // Флаг включения / выключения ноты
    bool bIsPlaying;
    // Номер текущего инструмента
    int iInstrument;
    // Выпадающий список устройств MIDI
    ComboBox* pMIDIDevicesBox;
    // Выпадающий список инструментов
    ComboBox* pInstrumentsBox;
    TextButton* pPlayButton;

    // Устройство вывода
    MidiOutput* pMidiOutput;

    // Добавляем новый инструмент в выпадающий список
    inline void AddInstruments();
    // Играем ноту
    void Play();
};
//---------------------------------------------------------------------
#endif
